/*	Copyright (C) 1997 Eugene G. Crosser and Sovam Teleport		*/

#ifndef LINT
static char *rscid="$Id: mcsname_bysocket.c,v 1.2 1999/08/26 12:17:48 crosser Exp $";
#endif

/*
	$Log: mcsname_bysocket.c,v $
	Revision 1.2  1999/08/26 12:17:48  crosser
	Working automakified/libtoolized version
	
	Revision 1.1  1997/10/21 12:09:52  crosser
	Initial revision
	
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#ifdef STDC_HEADERS
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif

#ifdef DEBUG
#ifdef STDC_HEADERS
# include <stdio.h>
#endif

extern int mcs_verbose;
#endif

char*
mcsname_bysocket(int fd)
{
	struct sockaddr_in sck;
	int scksz=sizeof(sck);
	struct hostent *he;
	char *p;

	if (getsockname(fd,(struct sockaddr*)&sck,&scksz) < 0)
	{
#ifdef DEBUG
		if (mcs_verbose) perror("getsockname");
#endif
		return NULL; /* this is not a socket, no translations */
	}

#ifdef DEBUG
	if (mcs_verbose > 1)
		fprintf(stderr,"getsockname returned 0x%8lx\n",
				(unsigned long)sck.sin_addr.s_addr);
#endif

	if ((he=gethostbyaddr((char *)&sck.sin_addr.s_addr,
		sizeof(sck.sin_addr.s_addr),
		sck.sin_family)) == NULL) {
#ifdef DEBUG
		if (mcs_verbose) perror("gethostbyaddr");
#endif
		return "/"; /* cannot back-resolve local address:
			this is severe problem, we better hush
			the user away.  Let him try when the
			nameserver is operational again. */
	}

	if ((p=strchr(he->h_name,'.'))) *p='\0';

	return he->h_name;
}
